/*****************************************************************************
 *   Copyright (C) 2009 Peter "woggle" Mack, mac@denich.net                  *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by    *
 *   the Free Software Foundation; either version 2 of the License.          *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU General Public License for more details.                            *
 *                                                                           *
 *   You should have received a copy of the GNU General Public License       *
 *   along with this program; if not, write to the                           *
 *   Free Software Foundation, Inc.,                                         *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.               *
 *                                                                           *
 *****************************************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <string.h>
#include <util/twi.h>
#include <util/delay.h>


#include "main.h"
#include "motortestI2C.h"
#include "lcd.h"
#include "usart.h"
#include "timer.h"
#include "twimaster.h"


uint8_t m;
//############################################################################
// Senden der Motorwerte per I2C-Bus
void SendMotorData(void)
//############################################################################
{
 unsigned char i;
    if(!MotorenEin)
        {
//         FC_StatusFlags &= ~(FC_STATUS_MOTOR_RUN | FC_STATUS_FLY);
		 for(i=0;i<MAX_MOTORS;i++)
		  {
//		   if(!PC_MotortestActive)  MotorTest[i] = 0;
//??		   MotorTest[i] = 0;
// 		   Motor[i].SetPoint = MotorTest[i];
//		   Motor[i].SetPointLowerBits = 0;
/*
 Motor[i].SetPoint = MotorTest[i] / 4;            // testing the high resolution
 Motor[i].SetPointLowerBits = MotorTest[i] % 4;
*/
		  }
//          if(PC_MotortestActive) PC_MotortestActive--;
//         PC_MotortestActive--;
        }


    if(I2C_TransferActive)
	 {
	  I2C_TransferActive = 0; // enable for the next time
	 }
	else
    {
     motor_write = 0;
     I2C_Start(TWI_STATE_MOTOR_TX); //Start I2C Interrupt Mode
	}
}

//#define SCL_FREQ  200000L
//
//#define I2C_STATE_TX_ADDRESS	0
//#define I2C_STATE_TX_DATA		1
//#define I2C_STATE_TX_STOP		2
//#define I2C_STATE_RX_ADDRESS	3
//#define I2C_STATE_RX_1BYTE		4
//#define I2C_STATE_RX_2BYTE		5
//
//volatile uint8_t i2c_state;
//uint8_t motor_addr_I2C = 0;
//
////*****************************************************************************
////
//void I2C_Init(void)
//{
//	uint8_t sreg = SREG;
//	cli();
//
//	DDRC  &= ~(1<<DDC1);	// SDA is input
//	DDRC |= (1<<DDC0);		// SCL is output
//	PORTC |= (1<<PORTC0)|(1<<PORTC1);	// pull up SDA and SCL
//
//	// prescaler 1 (TWPS1 = 0, TWPS0 = 0)
//	TWSR &= ~((1<<TWPS1)|(1<<TWPS0));
//
//	TWBR = ((F_CPU/SCL_FREQ)-16)/2;
//
//	i2c_state = I2C_STATE_TX_ADDRESS;
//
//	SREG = sreg;
//}
//
////*****************************************************************************
////
//void I2C_Start(uint8_t start_state)
//{
//	i2c_state = start_state;
//
//	// generate start condition and enable interrupts
//	TWCR = (1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (1<<TWIE);
//}
//
////*****************************************************************************
////
//void I2C_Stop(uint8_t start_state)
//{
//	i2c_state = start_state;
//
//	// generate stop condition and disable interrupt
//	TWCR = (1<<TWINT) | (1<<TWSTO) | (1<<TWEN);
//}
//
////*****************************************************************************
////
//void I2C_WriteByte(int8_t b)
//{
//	TWDR = b;
//	// clear interrupt flag (TWINT = 1)
//	// enable i2c bus (TWEN = 1)
//	// enable interrupt (TWIE = 1)
//	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWIE);
//}
//
////*****************************************************************************
////
//void I2C_ReceiveByte(void)
//{
//	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWIE) | (1<<TWEA);
//}
//
////*****************************************************************************
////
//void I2C_ReceiveLastByte(void)
//{
//	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWIE);
//}
//
//
////*****************************************************************************
////
//ISR (TWI_vect)
//{
//	int8_t mrCurrent;
//	int8_t mrMaxpwm;
//
//	switch (i2c_state++)
//	{
//		// TWI Master Transmit
//		case I2C_STATE_TX_ADDRESS:
//			I2C_WriteByte(0x52 + (motor_addr_I2C * 2) ); // select slave adress in tx mode
//			break;
//
//		case I2C_STATE_TX_DATA:
//			I2C_WriteByte(m);
//			break;
//
//		case I2C_STATE_TX_STOP:
//			if(TWSR == TW_MT_DATA_NACK) // Data transmitted, NACK received
//			{
//				// error occured
//			}
//			I2C_Stop(I2C_STATE_TX_ADDRESS);
//			I2C_Start(I2C_STATE_RX_ADDRESS); // Repeated start -> switch slave or switch Master Transmit -> Master Receive
//			break;
//
//			// Master Receive Data
//		case I2C_STATE_RX_ADDRESS:
//			I2C_WriteByte(0x53 + (motor_addr_I2C * 2) ); // select slave adress in rx mode
//			if(TWSR != TW_MR_SLA_ACK) //  SLA+R transmitted, if not ACK received
//			{	// no response from the addressed slave received
//				I2C_Stop(I2C_STATE_TX_ADDRESS);
//			}
//			else
//			{
//				I2C_ReceiveByte(); //Transmit 1st byte
//			}
//			break;
//
//		case I2C_STATE_RX_1BYTE: //Read 1st byte and transmit 2nd Byte
//			mrCurrent = TWDR;
//			I2C_ReceiveLastByte(); // nack
//			break;
//
//		case I2C_STATE_RX_2BYTE:
//			//Read 2nd byte
//			mrMaxpwm = TWDR;;
//			I2C_Stop(I2C_STATE_TX_ADDRESS);
//			break;

//		default:
//			I2C_Stop(I2C_STATE_TX_ADDRESS);
//			break;
//	}
//}

//*****************************************************************************
// 
void motor_i2c (void)
{
	uint8_t i = 0;
	unsigned int timer;
	lcd_cls ();
	m = 0;
	MotorenEin =0;

	
	lcd_printp (PSTR("I2C Motor Test"), 0);
	
	// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// + Check connected BL-Ctrls
	// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		// Check connected BL-Ctrls
		BLFlags |= BLFLAG_READ_VERSION;
		motor_read = 0;  // read the first I2C-Data
//		set_LED1();


		SendMotorData();
//		timer = SetDelay(500);
		timer = SetDelay(1);
		while(!(BLFlags & BLFLAG_TX_COMPLETE) && !CheckDelay(timer)); //wait for complete transfer

//	    printf("\n\rFound BL-Ctrl: ");
//	    lcd_printpns_at (0, 7, PSTR("Found BL-Ctrl:"), 0);

//	    timer = SetDelay(4000);
	    timer = SetDelay(1);
		for(i=0; i < MAX_MOTORS; i++)
		{

			SendMotorData();


			while(!(BLFlags & BLFLAG_TX_COMPLETE)  && !CheckDelay(timer)); //wait for complete transfer
//			if(Mixer.Motor[i][0] > 0) // wait max 4 sec for the BL-Ctrls to wake up

//			{


				while(!CheckDelay(timer) && !(Motor[i].State & MOTOR_STATE_PRESENT_MASK) )
				{
					SendMotorData();
					while(!(BLFlags & BLFLAG_TX_COMPLETE) && !CheckDelay(timer)); //wait for complete transfer

				}
//			}


//				Motor[i].Version	= 0;
//				Motor[i].SetPoint	= 0;
//				Motor[i].SetPointLowerBits	= 0;
//				Motor[i].State		= 0;
//				Motor[i].ReadMode	= BL_READMODE_STATUS;
//				Motor[i].Current	= 0;
//				Motor[i].MaxPWM		= 0;
//				Motor[i].Temperature = 0;


			if(Motor[i].State & MOTOR_STATE_PRESENT_MASK)
			{
//				printf("%d",i+1);
				lcd_printpns_at (0, 1, PSTR("Found BL-Ctrl:"), 0);
				lcd_print_hex_at (18,1,i,0);

				lcd_printpns_at (0, 2, PSTR("Version:"), 0);
				lcd_print_hex_at (8,2,Motor[i].Version,0);
				lcd_printpns_at (11, 2, PSTR("SetPoi:"), 0);
				lcd_print_hex_at (18,2,Motor[i].SetPoint,0);

				lcd_printpns_at (0, 3, PSTR("SetPoiL:"), 0);
				lcd_print_hex_at (8,3,Motor[i].SetPointLowerBits,0);
				lcd_printpns_at (11, 3, PSTR("State :"), 0);
				lcd_print_hex_at (18,3,Motor[i].State,0);

				lcd_printpns_at (0, 4, PSTR("ReadMod:"), 0);
				lcd_print_hex_at (8,4,Motor[i].ReadMode,0);
				lcd_printpns_at (11, 4, PSTR("Currnt:"), 0);
				lcd_print_hex_at (18,4,Motor[i].Current,0);

				lcd_printpns_at (0, 5, PSTR("MaxPWM :"), 0);
				lcd_print_hex_at (8,5,Motor[i].MaxPWM,0);
				lcd_printpns_at (11, 5, PSTR("Temp  :"), 0);
				lcd_print_hex_at (18,5,Motor[i].Temperature,0);





//				write_ndigit_number_u (18,2,i,1, 0);
//				FoundMotors++;
//			if(Motor[i].Version & MOTOR_STATE_NEW_PROTOCOL_MASK) printf("(new) ");
			}

//			else
//			{
////				printf("%d",i+1);
//				lcd_printpns_at (0, 3, PSTR("no BL found"), 0);
//				lcd_print_hex_at (18,3,i,0);
//			}

		}


		lcd_printpns_at (0, 7, PSTR("dec  inc    Exit Oxff"), 0);
//		set_BEEP();
//		set_LED1();
//		_delay_ms(2000);
//		while (!(get_key_press (1 << KEY_ENTER)));


//		clr_LED1();
//		clr_BEEP();
//		lcd_printpns_at (16,4,"   ",0);

//		for(i=0; i < MAX_MOTORS; i++)
//		{

//
////			set_BEEP();
//
////			if(!(Motor[i].State & MOTOR_STATE_PRESENT_MASK) && Mixer.Motor[i][0] > 0)
//			if(!(Motor[i].State & MOTOR_STATE_PRESENT_MASK))
//			{
////				printf("\n\r\n\r!! MISSING BL-CTRL: %d !!",i+1);
//
//			    lcd_printpns_at (0, 4, PSTR("BL fehlt:# "), 0);
////			    lcd_write_number_u(i);
//			    lcd_print_hex_at (16,4,i,0);
//
//				_delay_ms(500);
////				ServoActive = 2; // just in case the FC would be used as camera-stabilizer
//			}
//
////		    lcd_print_hex_at (17,6,i,0);
//			Motor[i].State &= MOTOR_STATE_ERROR_MASK; // clear error counter
//		}
//
//
//
//
//
//
////	 	printf("\n\r===================================");
//
//		set_LED2();
//
//		_delay_ms(10000);


//		clr_BEEP();

//		while (!(get_key_press (1 << KEY_ENTER)));
//		for (;;)
//		{
//
//		}

//	lcd_printpns_at (0, 7, PSTR("dec  inc    Exit Oxff"), 0);
//
//	lcd_printp (PSTR("BLC #"), 0);
//
//	do
//	{
//		if ((get_key_press (1 << KEY_PLUS) || get_key_rpt (1 << KEY_PLUS)) && (m < 254))
//		{
//			m++;
//		}
//		if ((get_key_press (1 << KEY_MINUS) || get_key_rpt (1 << KEY_MINUS)) && (m > 0))
//		{
//			lcd_frect (GX, GY, (m * 108) / 255, 10, 0);
//			m--;
//		}
//		if (get_key_press (1 << KEY_ENTER))
//		{
//			lcd_frect (GX, GY, (m * 108) / 255, 10, 0);
//			m = 0;
//		}
//	}
	while (!get_key_press (1 << KEY_ESC));
//
	// switch all engines off at exit !
}




